# cellrenderer_timetrack.cpp File Reference

Template Header. More...

`#include <gtkmm/label.h>`
`#include "cellrenderer_timetrack.h"`
`#include <gtk/gtk.h>`
`#include <gtkmm/spinbutton.h>`
`#include <gtkmm/combo.h>`
`#include <ETL/stringf>`
`#include "widget_value.h"`
`#include "app.h"`
`#include <gtkmm/menu.h>`
`#include <gtkmm/optionmenu.h>`
`#include "widget_time.h"`
`#include "widget_timeslider.h"`
`#include <synfigapp/canvasinterface.h>`
`#include "instance.h"`
`#include "general.h"`

## Enumerations

enum | MODMODE { NONE = 0, SELECT_MASK = Gdk::CONTROL_MASK, COPY_MASK = Gdk::SHIFT_MASK, DELETE_MASK = Gdk::MOD1_MASK }

## Functions

const synfig::Time | get_time_offset_from_vdesc (const synfigapp::ValueDesc &v)
const synfig::Node::time_set * | get_times_from_vdesc (const synfigapp::ValueDesc &v)
bool | get_closest_time (const synfig::Node::time_set &tset, const Time &t, const Time &range, Time &out)

## Variables

static char | stipple_xpm [] = { 2, 0 }

## Detailed Description

Template Header.

$Id$

## Enumeration Type Documentation

enum MODMODE

Enumerator:

  NONE |
  SELECT_MASK |
  COPY_MASK |
  DELETE_MASK |

## Function Documentation

const synfig::Time get_time_offset_from_vdesc | ( | const synfigapp::ValueDesc & | v | ) |

References synfigapp::ValueDesc::get_layer(), synfigapp::ValueDesc::get_value(), synfigapp::ValueDesc::get_value_type(), and synfigapp::ValueDesc::parent_is_layer_param().

Referenced by studio::CellRenderer_TimeTrack::activate_vfunc(), and studio::CellRenderer_TimeTrack::render_vfunc().

const synfig::Node::time_set* get_times_from_vdesc | ( | const synfigapp::ValueDesc & | v | ) |

References synfigapp::ValueDesc::get_index(), synfigapp::ValueDesc::get_parent_value_node(), synfigapp::ValueDesc::get_value(), synfigapp::ValueDesc::get_value_node(), synfigapp::ValueDesc::get_value_type(), and synfigapp::ValueDesc::parent_is_value_node().

Referenced by studio::CellRenderer_TimeTrack::activate_vfunc(), and studio::CellRenderer_TimeTrack::render_vfunc().

bool get_closest_time | ( | const synfig::Node::time_set & | tset,
|  | const Time & | t,
|  | const Time & | range,
|  | Time & | out |
| ) |  |  |

Referenced by studio::CellRenderer_TimeTrack::activate_vfunc().

## Variable Documentation

char stipple_xpm[] = { 2, 0 }`[static]`

Referenced by studio::CellRenderer_TimeTrack::render_vfunc().